using System;

namespace Baloo
{
    class BalooReply
    {
        public enum Types {
            Text,
            Filename,
            Filebuffer
        }
        public Types Type;
        public string Text;
        public string Filename;
        public byte[] Databuffer;

        public BalooReply(Types type, string parameter)
        {
            this.Type = type;
            if (type == Types.Text)
                this.Text = parameter;
            else if (type == Types.Filename)
                this.Filename = parameter;
        }

        public BalooReply(string filename, string text)
        {
            this.Type = Types.Text;
            this.Text = text;
            this.Filename = filename;
        }

        public BalooReply(string filename, byte[] buffer)
        {
            this.Type = Types.Filebuffer;
            this.Filename = filename;
            this.Databuffer = buffer;
        }
    }
}
