/* BalooResource
 * Author: Johan Ho
 */
using System;

namespace Baloo
{
    /// <summary>
    /// This class describes a resource, which the users can access via the broadcast.
    /// </summary>
    public class BalooResource:IComparable
    {
        public enum ResourceTypes
        {
            CommandList, File, Folder, URL
        }
        public ResourceTypes ResourceType;
        private string name;
        public string Name
        {
            get { return name; }
            set { name = value; }
        }
        private string command;
        public string Command
        {
            get { return command; }
            set { command = value; }
        }
        private string description;
        public string Description
        {
            get { return description; }
            set { description = value; }
        }
        private string location; // either path to a file, a path to a folder, or a URL
        public string Location
        {
            get { return location; }
            set { location = value; }
        }
        public bool disabled;
        public bool Disabled
        {
            get { return disabled; }
            set { disabled = value; }
        }
        public bool hidden;
        public bool Hidden
        {
            get { return hidden; }
            set { hidden = value; }
        }

        public BalooResource()
        {
            name = "New resource";
        }

        /// <summary>
        /// This defines the comparer to compare the resource objects by their names.
        /// That way, when they are sorted for viewing in the GUI's ListBox, they are
        /// sorted by their names.
        /// </summary>
        /// <param name="obj">The object to compare to this object.</param>
        /// <returns>0 if the objects' names are the same, otherwise a nonzero value.</returns>
        public int CompareTo(object obj)
        {
            return Name.CompareTo(((BalooResource)obj).Name);
        }
    }
}
