/* BalooSettings
 * Author: Johan Ho
 */
using System;
using System.Collections;
using System.Xml.Serialization;

namespace Baloo
{
    /// <summary>
    /// This class just stores the settings, and uses Xml serializing for saving
    /// the configuration to a file.
    /// </summary>
    public class BalooSettings
    {
        #region Private variables used by the public variables
        private string incomingfilesaved;
        private string incomingfilenotaccepted;
        private string resourceunavailable;
        private string filenotfound;
        private string name;
        private string saveincomingtofolder;
        private string incomingfilter;
        private string logfile;
        private string mysqlserver;
        private string mysqlusername;
        private string mysqlpassword;
        private string mysqldatabase;
        #endregion

        #region User messages variables
        /* The following variables are used for adding user messages (messages
         * that are returned to the user in case of errors) that can be changed
         * in the GUI. The GUI uses the Messages string array in a ComboBox for
         * choosing which message to edit. This way, the GUI doesn't need to be
         * redesigned if new messages are added.
         * 
         * OBS: BalooGUI.SettingsChanged() still needs to be changed for the
         * messages to be stored properly into BalooSettings.
         */
        public const int MSG_INCOMINGFILESAVED = 0;
        public const int MSG_INCOMINGFILENOTACCEPTED = 1;
        public const int MSG_RESOURCEUNAVAILABLE = 2;
        public const int MSG_FILENOTFOUND = 3;
        public static string[] Messages
        {
            get {
                return new string[] {
                    "Incoming file saved",
                    "Incoming file not accepted",
                    "Resource unavailable error",
                    "File not found error"
                };
            }
        }
        public string IncomingFileSaved
        {
            get { return incomingfilesaved; }
            set { incomingfilesaved = value; }
        }
        public string IncomingFileNotAccepted
        {
            get { return incomingfilenotaccepted; }
            set { incomingfilenotaccepted = value; }
        }
        public string ResourceUnavailable
        {
            get { return resourceunavailable; }
            set { resourceunavailable = value; }
        }
        public string FileNotFound
        {
            get { return filenotfound; }
            set { filenotfound = value; }
        }
        #endregion

        public string Name
        {
            get { return name; }
            set { name = value; }
        }
        public string SaveIncomingToFolder
        {
            get { return saveincomingtofolder; }
            set { saveincomingtofolder = value; }
        }
        public string IncomingFilter
        {
            get { return incomingfilter; }
            set { incomingfilter = value; }
        }
        public string LogFile
        {
            get { return logfile; }
            set { logfile = value; }
        }
        public string MySQLServer
        {
            get { return mysqlserver; }
            set { mysqlserver = value; }
        }
        public string MySQLUsername
        {
            get { return mysqlusername; }
            set { mysqlusername = value; }
        }
        public string MySQLPassword
        {
            get { return mysqlpassword; }
            set { mysqlpassword = value; }
        }
        public string MySQLDatabase
        {
            get { return mysqldatabase; }
            set { mysqldatabase = value; }
        }

        // The XmlElement part makes sure the items in the Resources ArrayList
        // are stored properly.
        [XmlElement(Type = typeof(BalooResource))]
        public ArrayList Resources;

        public BalooSettings()
        {
            Resources = new ArrayList();
        }
    }
}
